
const MAX_LICZBA_PUNKTOW = 1200;
const MAX_LICZBA_WARSTW = 1200;


//########################################################################################################

type TypElKol = record
	element : Integer;
	warstwa : Integer;
end;

type TypKolejka = record
	elementy : array [0..MAX_LICZBA_PUNKTOW] of TypElKol;
	pierwszy : Integer;
	ostatni : Integer;
end;

procedure kolejkaInic( var kolejka : TypKolejka ); inline;
begin
	kolejka.pierwszy := 1;
	kolejka.ostatni := 0;
end;

procedure kolejkaInc( var i : Integer );
begin
	if( i < MAX_LICZBA_PUNKTOW ) then i += 1
	else i := 0;
end;

procedure kolejkaDodaj( var kolejka : TypKolejka; element : Integer; warstwa : Integer ); inline;
begin
	kolejkaInc( kolejka.ostatni );
	kolejka.elementy[ kolejka.ostatni ].element := element;
	kolejka.elementy[ kolejka.ostatni ].warstwa := warstwa;
end;

procedure kolejkaWez( var kolejka : TypKolejka; var element : Integer; var warstwa : Integer );
begin
	element := kolejka.elementy[ kolejka.pierwszy ].element;
	warstwa := kolejka.elementy[ kolejka.pierwszy ].warstwa;
	kolejkaInc( kolejka.pierwszy );
end;

function kolejkaPusta( var kolejka : TypKolejka ) : Boolean; inline;
var i : Integer;
begin
	i := kolejka.ostatni;
	kolejkaInc( i );
	kolejkaPusta := ( i = kolejka.pierwszy );
end;
(*
var kolej : TypKolejka;
procedure kolejkaTest(); inline;
var a, b : Integer;
begin
	writeln( 'Test kolejki' );
	kolejkaInic(kolej);
	kolejkaDodaj(kolej, 1, 11);
	kolejkaDodaj(kolej, 3, 13);
	kolejkaWez(kolej, a, b );
	writeln( a, ' ', b );
	kolejkaDodaj(kolej, 2, 12);
	kolejkaWez(kolej, a, b );
	writeln( a, ' ', b );
	kolejkaWez(kolej, a, b );
	writeln( a, ' ', b );
	writeln( 'Test kolejki' );
end;
*)
//########################################################################################################

type TypIterator = record
	elementy : array [0..MAX_LICZBA_PUNKTOW] of Integer;
	rozmiar : Integer;
end;

procedure iteratorInic( var iterator : TypIterator ); inline;
begin
	iterator.rozmiar := 0;
end;

procedure iteratorDodaj( var iterator : TypIterator; element : Integer ); inline;
begin
	iterator.elementy[ iterator.rozmiar ] := element;
	iterator.rozmiar += 1;
end;

procedure iteratorWypisz( var iterator : TypIterator ); inline;
var i : Integer;
begin
	write( 'ilosc: ', iterator.rozmiar, ' elementy: ' );
	for i:=0 to iterator.rozmiar-1 do write( iterator.elementy[i], ' ' );
	writeln();
end;

//########################################################################################################

type TypSlownik = record
	funCharakt : array [0..MAX_LICZBA_PUNKTOW] of Integer;
	elementy : array [0..MAX_LICZBA_PUNKTOW] of Integer;
	rozmiar : Integer;
end;

procedure slownikInic( var slownik : TypSlownik ); inline;
var i : Integer;
begin
	slownik.rozmiar := 0;
	for i:=0 to MAX_LICZBA_PUNKTOW-1 do slownik.funCharakt[i]:=-1;
end;

procedure slownikReinic( var slownik : TypSlownik ); inline;
var i, slownikRozmiar : Integer;
begin
	slownikRozmiar := slownik.rozmiar;
	for i:=0 to slownikRozmiar-1 do slownik.funCharakt[ slownik.elementy[i] ]:=-1;
	slownik.rozmiar := 0;
end;

procedure slownikDodaj( var slownik : TypSlownik; element : Integer ); inline;
begin
	if ( slownik.funCharakt[ element ] = -1 ) then
	begin
		slownik.elementy[ slownik.rozmiar ] := element;
		slownik.funCharakt[ element ] := slownik.rozmiar;
		slownik.rozmiar += 1;
	end;
end;

procedure slownikUsun( var slownik : TypSlownik; elementUsun : Integer ); inline;
var pozycUsun, elementZmien : Integer;
begin
	pozycUsun := slownik.funCharakt[ elementUsun ];
	elementZmien := slownik.elementy[ slownik.rozmiar-1 ];
	if ( pozycUsun <> -1 ) then
	begin
		slownik.elementy[ pozycUsun ] := elementZmien;
		slownik.funCharakt[ elementZmien ] := pozycUsun;
		slownik.funCharakt[ elementUsun ] := -1;
		slownik.rozmiar -= 1;
	end;
end;

procedure slownikWypisz( var slownik : TypSlownik ); inline;
var i : Integer;
begin
	write( 'ilosc: ', slownik.rozmiar, ' elementy: ' );
	for i:=0 to slownik.rozmiar-1 do write( slownik.elementy[i], ' ' );
	writeln();
end;

(*var slow : TypSlownik;
procedure slownikTest();
begin
	writeln( 'Test slownika' );
	slownikInic(slow);
	slownikDodaj(slow, 1);
	slownikDodaj(slow, 3);
	slownikDodaj(slow, 2);
	slownikWypisz(slow);
	slownikUsun(slow, 2);
	slownikWypisz(slow);
	writeln( 'Test slownika' );
end;*)

//########################################################################################################

type TypPoset = record
	relacja : array [0..MAX_LICZBA_PUNKTOW] of array [0..MAX_LICZBA_PUNKTOW] of Boolean;
	rozmiar : Integer;
	elementyM : array [0..MAX_LICZBA_PUNKTOW] of array [0..MAX_LICZBA_PUNKTOW] of Integer;
	rozmiaryM : array [0..MAX_LICZBA_PUNKTOW] of Integer;
	elementyW : array [0..MAX_LICZBA_PUNKTOW] of array [0..MAX_LICZBA_PUNKTOW] of Integer;
	rozmiaryW : array [0..MAX_LICZBA_PUNKTOW] of Integer;
end;

var poset : TypPoset;

procedure posetWypisz(); inline;
var i, j, r : Integer;
begin
//	writeln( '####################### POSET: #######################' );
	writeln( poset.rozmiar );
	for i:=0 to poset.rozmiar-1 do 
	begin
		write( '  ', i, ':	' );
		for j:=0 to poset.rozmiar-1 do
		begin
			if ( poset.relacja[i][j] ) then r := 1 else r := 0;
			write( r ); //, ' ' );
		end;
		writeln();
	end;
(*	for i:=0 to poset.rozmiar-1 do 
	begin
		write( i, ': ' );
		for j:=0 to poset.rozmiaryW[i]-1 do
		begin
			write( poset.elementyW[i][j], ' ' );
		end;
		writeln();
	end;
	for i:=0 to poset.rozmiar-1 do 
	begin
		write( i, ': ' );
		for j:=0 to poset.rozmiaryM[i]-1 do
		begin
			write( poset.elementyM[i][j], ' ' );
		end;
		writeln();
	end;*)
end;

var Buf : array[0..65000] of Byte;

procedure posetPrzeczytaj(); inline;
var	i, j	: Integer;
		cc		: Char;
begin
	read( poset.rozmiar );
	for i:=0 to poset.rozmiar-1 do for j:=0 to poset.rozmiar-1 do
	begin
		repeat read( cc ) until ((cc = '0') OR (cc = '1'));
		poset.relacja[i][j] := ( cc = '1' );
	end;
	// MNIEJSZE
	for i:=0 to poset.rozmiar-1 do
	begin
		poset.rozmiaryM[i] := 0;
		for j:=0 to poset.rozmiar-1 do
		begin
			if ( poset.relacja[j][i] ) then
			begin
				poset.rozmiaryM[i] += 1;
				poset.elementyM[i][poset.rozmiaryM[i]-1] := j;
			end
		end
	end;
	// WIEKSZE
	for i:=0 to poset.rozmiar-1 do
	begin
		poset.rozmiaryW[i] := 0;
		for j:=0 to poset.rozmiar-1 do
		begin
			if ( poset.relacja[i][j] ) then
			begin
				poset.rozmiaryW[i] += 1;
				poset.elementyW[i][poset.rozmiaryW[i]-1] := j;
			end
		end
	end
end;

//########################################################################################################

type TypPrzyparz = record
	funDoGory	: array [0..MAX_LICZBA_PUNKTOW] of Integer;
	funNaDol	: array [0..MAX_LICZBA_PUNKTOW] of Integer;
	rozmiar : Integer;
end;

var przyparz : TypPrzyparz;

procedure przyparzInic(); inline;
var i : Integer;
begin
	przyparz.rozmiar := poset.rozmiar;
	for i:=0 to przyparz.rozmiar-1 do
	begin
		przyparz.funDoGory[i] := -1;
		przyparz.funNaDol[i] := -1;
	end
end;

//########################################################################################################

type TypZbiorWarstw = record
	warstwy : array [0..MAX_LICZBA_WARSTW-1] of TypSlownik;
	rozmiar : Integer;
end;

var zbiorWarstw : TypZbiorWarstw;
var stopnieElementow : array [ 0..MAX_LICZBA_PUNKTOW ] of integer;

procedure zbiorWarstwInic(); inline;
var i : Integer;
begin
	zbiorWarstw.rozmiar := 0;
	for i:=0 to MAX_LICZBA_WARSTW-1 do slownikInic( zbiorWarstw.warstwy[i] );
end;

procedure zbiorWarstwReinic(); inline;
var i : Integer;
begin
	for i:=0 to zbiorWarstw.rozmiar-1 do slownikReinic( zbiorWarstw.warstwy[i] );
	zbiorWarstw.rozmiar := 0;
end;

//########################################################################################################

var elementyPoszerzajace, elementyWWarstwach : TypSlownik;

var sciezPow : TypIterator;
var kolejkaCzysz : TypKolejka;

(*
var zbiorTestowy : TypSlownik;
procedure testujPrzyparz();
var	i					: Integer;
		ok1, ok2, ok3	: Boolean;
begin
	// CZY FUNKCJA DO GORY MOWI O TYM SAMYM CO FUNKCJA NA DOL
	ok1 := TRUE;
	for i:=0 to przyparz.rozmiar-1 do
	begin
		ok2 := ( przyparz.funNaDol[i] = -1 ) OR ( przyparz.funDoGory[ przyparz.funNaDol[i] ] = i );
		ok3 := ( przyparz.funDoGory[i] = -1 ) OR ( przyparz.funNaDol[ przyparz.funDoGory[i] ] = i );
		ok1 := ok1 AND ok2 AND ok3;
		if ( NOT ok2 ) then writeln( 'BLAD0 w funNaDol[ ', i, ' ] = ', przyparz.funNaDol[i], ' a funDoGory[ ', przyparz.funNaDol[i], ' ] = ', przyparz.funDoGory[ przyparz.funNaDol[i] ] );
		if ( NOT ok3 ) then writeln( 'BLAD0 w funDoGory[ ', i, ' ] = ', przyparz.funDoGory[i], ' a funNaDol[ ', przyparz.funDoGory[i], ' ] = ', przyparz.funNaDol[ przyparz.funDoGory[i] ] );
	end;
	if ( ok1 ) then writeln( 'OK Funkcja na dol i do gory to to samo' )
	else writeln( 'BLAD!!!! Funkcja na dol i do gory to nie to samo' );

	slownikInic( zbiorTestowy );
	for i:=0 to przyparz.rozmiar-1 do
	begin
		if ( przyparz.funDoGory[i] <> -1 ) then
		begin
			if ( zbiorTestowy.funCharakt[ przyparz.funDoGory[i] ] = -1 )
			then slownikDodaj( zbiorTestowy, przyparz.funDoGory[i] )
			else writeln( 'BLAD1 - zlamanie injektywnosci funDoGory[ ', i, ' ] = ', przyparz.funDoGory[i] );
		end;
	end;
	slownikReinic( zbiorTestowy );
	for i:=0 to przyparz.rozmiar-1 do
	begin
		if ( przyparz.funNaDol[i] <> -1 ) then
		begin
			if ( zbiorTestowy.funCharakt[ przyparz.funNaDol[i] ] = -1 )
			then slownikDodaj( zbiorTestowy, przyparz.funNaDol[i] )
			else writeln( 'BLAD1 - zlamanie injektywnosci funNaDol[ ', i, ' ] = ', przyparz.funNaDol[i] );
		end;
	end;
end;

var nrWypisu : Integer;
procedure wypisz( i : Integer );
var j, k : Integer;
begin
	writeln( '####################### ', i, ' NR_WYPISU_', nrWypisu, ' ######################' );

		//write( 'Elelemnty mniejsze od 42: ' );
		//for k:=0 to poset.rozmiaryM[42]-1 do write( poset.elementyM[42][k], ' ' );
		//writeln();

	//posetWypisz();
	writeln( 'ELEMENTY POSZERZAJACE:' );
	slownikWypisz( elementyPoszerzajace );
	writeln( 'KOLEJNE WARSTWY:' );
	for j:=0 to zbiorWarstw.rozmiar-1 do 
	begin
		write( 'nr warstwy: ', j, ' rozmiar: ', zbiorWarstw.warstwy[j].rozmiar, ' ' );
		for k:=0 to zbiorWarstw.warstwy[j].rozmiar-1 do
			write( '(', zbiorWarstw.warstwy[j].elementy[k], ' ', stopnieElementow[zbiorWarstw.warstwy[j].elementy[k]], ') ' );
		writeln();
		//slownikWypisz( zbiorWarstw.warstwy[ j ] );
	end;
	writeln( 'ZNALEZIONA SCIEZKA POW:' );
	iteratorWypisz( sciezPow );
	writeln( 'FUNKCJA DO GORY' );
	for i:=0 to przyparz.rozmiar-1 do write( '(', i, ' ', przyparz.funDoGory[i], ') ' );
	writeln();
	writeln( 'FUNKCJA NA DOL' );
	for i:=0 to przyparz.rozmiar-1 do write( '(', i, ' ', przyparz.funNaDol[i], ') ' );
	writeln();
	testujPrzyparz();
	writeln( '################### KONIEC ###########################' );
	nrWypisu += 1;
end;
*)

procedure pierWarstwa(); inline;
var i : Integer;
begin
	zbiorWarstw.rozmiar := 1;
	for i:=0 to przyparz.rozmiar-1 do if ( przyparz.funDoGory[i] = -1 ) then
		slownikDodaj( zbiorWarstw.warstwy[0], i );
end;

procedure kolWarstwa(); inline;
var	i, j, el, elSasiedni : Integer;
begin

	// DODAWANIE NIEPARZYSTEJ WARSTWY
	zbiorWarstw.rozmiar += 1;
	for i:=0 to zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-2 ].rozmiar-1 do
	begin
		el := zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-2 ].elementy[i];
		for j := 0 to poset.rozmiaryW[el]-1 do
		begin
			elSasiedni := poset.elementyW[el][j];
			if ( zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].funCharakt[ elSasiedni ] <> -1 )
				then stopnieElementow[ elSasiedni ] += 1;
			if (  elementyWWarstwach.funCharakt[ elSasiedni ] = -1 ) then
			begin
				slownikDodaj( zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ], elSasiedni );
				slownikDodaj( elementyWWarstwach, elSasiedni );
				stopnieElementow[ elSasiedni ] := 1
			end
		end;
	end;

	// SPRAWDZANIE CZY TO KONIEC
	for i:=0 to zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].rozmiar-1 do
	begin
		el := zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].elementy[i];
		if ( przyparz.funNaDol[el] = -1 ) then slownikDodaj( elementyPoszerzajace, el );
	end;

	// DODAWANIE PARZYSTEJ WARSTWY
	if ( ( elementyPoszerzajace.rozmiar = 0 ) AND ( zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].rozmiar <> 0 ) ) then
	begin
		zbiorWarstw.rozmiar += 1;
		for i:=0 to zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-2 ].rozmiar-1 do
			slownikDodaj (
				zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ],
				przyparz.funNaDol[ zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-2 ].elementy[i] ]
			);
 	end;

end;

procedure czyszczenie(); inline;
var element, elementSasiad, warstwa, i : Integer;
begin
	while ( NOT kolejkaPusta( kolejkaCzysz ) ) do
	begin
		kolejkaWez( kolejkaCzysz, element, warstwa );
		if ( ( warstwa mod 2 ) = 1 ) then
		begin

			// TYLKO USUWAMY ELEMENT
			slownikUsun( zbiorWarstw.warstwy[ warstwa ], element );

		end
		else begin

			// USUWAMY ELEMENT  ORAZ POJEDYNCZE SCIEZKI W GORE
			slownikUsun( zbiorWarstw.warstwy[ warstwa ], element );
			for i:=0 to poset.rozmiaryW[ element ]-1 do
				if ( zbiorWarstw.warstwy[ warstwa+1 ].funCharakt[ poset.elementyW[element][i] ] <> -1 ) then
			begin
				elementSasiad := poset.elementyW[element][i];
				if ( stopnieElementow[ elementSasiad ] <= 1 ) then
				begin
					slownikUsun( zbiorWarstw.warstwy[ warstwa+1 ], elementSasiad );
					if ( warstwa+2 <= zbiorWarstw.rozmiar-1 ) then
						kolejkaDodaj( kolejkaCzysz, przyparz.funNaDol[ elementSasiad ], warstwa+2 );
				end
				else stopnieElementow[ elementSasiad ] -= 1;
			end;

		end;
	end;
end;

procedure powieksz(); inline;
var elementBierzacy, nrBiezWarstwy, i, j : Integer;
begin

	while ( 0 < elementyPoszerzajace.rozmiar ) do
	begin

		//INICJALIZACJA SCIEZKI POWIEKSZAJACEJ
		iteratorInic( sciezPow );

		//POBRANIE KOLEJNEGO ELEMENTU POCZATKOWEGO SCIEZKI POWIEKSZJACEJ
		elementBierzacy := elementyPoszerzajace.elementy[ 0 ];
		slownikUsun( elementyPoszerzajace, elementBierzacy );

		if( zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].funCharakt[elementBierzacy] <> -1 ) then
		begin
			
			// DODANIE DO SCIEZKI POWIEKSZAJACEJ ELEMENTU Z OSTATNIEJ WARSTWY
			iteratorDodaj( sciezPow, elementBierzacy );
			kolejkaDodaj( kolejkaCzysz, elementBierzacy, zbiorWarstw.rozmiar-1 ); 

			// DODANIE DO SCIEZKI POWIEKSZAJACEJ ELEMENTU Z PRZEDOSTATNIEJ WARSTWY
			j := 0;
			while (
				( zbiorWarstw.warstwy[zbiorWarstw.rozmiar-2].funCharakt[ poset.elementyM[elementBierzacy][ j ] ] = -1 )
				AND ( j < poset.rozmiaryM[elementBierzacy] )
			) do j += 1;
			elementBierzacy := poset.elementyM[elementBierzacy][j];
			iteratorDodaj( sciezPow, elementBierzacy );
			kolejkaDodaj( kolejkaCzysz, elementBierzacy, zbiorWarstw.rozmiar-2 );

			nrBiezWarstwy := zbiorWarstw.rozmiar-3;
			while ( 0 <= nrBiezWarstwy  ) do
			begin

				elementBierzacy := przyparz.funDoGory[ elementBierzacy ];
				iteratorDodaj( sciezPow, elementBierzacy );
				kolejkaDodaj( kolejkaCzysz, elementBierzacy, nrBiezWarstwy ); 
				nrBiezWarstwy -= 1;

				j := 0;
				while (
					( zbiorWarstw.warstwy[nrBiezWarstwy].funCharakt[ poset.elementyM[elementBierzacy][ j ] ] = -1 )
					AND ( j < poset.rozmiaryM[elementBierzacy] )
				) do j += 1;
				elementBierzacy := poset.elementyM[elementBierzacy][j];
				iteratorDodaj( sciezPow, elementBierzacy );
				kolejkaDodaj( kolejkaCzysz, elementBierzacy, nrBiezWarstwy );
				nrBiezWarstwy -= 1;

			end;

			czyszczenie();

			for i:=0 to sciezPow.rozmiar-2 do if ( ( i mod 2 ) = 0 ) then
			begin
				przyparz.funDoGory[ sciezPow.elementy[i+1] ] := sciezPow.elementy[i];
				przyparz.funNaDol[ sciezPow.elementy[i] ] := sciezPow.elementy[i+1];
			end;

		end;
	end;
end;

procedure faza(); inline;
begin
	kolejkaInic( kolejkaCzysz );
	slownikReinic( elementyPoszerzajace );
	slownikReinic( elementyWWarstwach );
	pierWarstwa();
	repeat
		kolWarstwa();
	until ( elementyPoszerzajace.rozmiar <> 0 ) OR ( zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].rozmiar = 0 );
end;

procedure znajdzPrzyparz(); inline;
var rozmiarOstatWarstwy : Integer;
begin
	zbiorWarstwReinic();
	przyparzInic();
	repeat
		faza();
		rozmiarOstatWarstwy := zbiorWarstw.warstwy[ zbiorWarstw.rozmiar-1 ].rozmiar;
		powieksz();
	until rozmiarOstatWarstwy = 0;
end;


var elementyPosetu : TypSlownik;
procedure wypiszLancuchy(); inline;
var i, j, el : Integer;
begin

	j := 0;
	for i:=0 to poset.rozmiar-1 do if ( przyparz.funDoGory[i] <> -1 ) then j += 1;
	writeln( poset.rozmiar - j );

	slownikReinic( elementyPosetu );
	for i:=0 to poset.rozmiar-1 do slownikDodaj( elementyPosetu, i );
	while ( 0 < elementyPosetu.rozmiar ) do
	begin
		el := elementyPosetu.elementy[0];
		while ( przyparz.funNaDol[ el ] <> -1 ) do el := przyparz.funNaDol[ el ];
		repeat
			write( el+1, ' ' );
			slownikUsun( elementyPosetu, el );
			el := przyparz.funDoGory[ el ];
		until el = -1;
		writeln();
	end;
	(* writeln(); *)

end;

//########################################################################################################

procedure superTest();
var i, j, k : Integer;
begin
	for i:=0 to poset.rozmiar-1 do for j:=0 to poset.rozmiar-1 do for k:=0 to poset.rozmiar-1 do
	begin
		if ( ( i <> j ) AND ( i <> k ) AND ( j <> k ) ) then
		begin
			if (
				( NOT poset.relacja[i][j] )
				AND ( NOT poset.relacja[j][i] )
				AND ( NOT poset.relacja[i][k] )
				AND ( NOT poset.relacja[k][i] )
				AND ( NOT poset.relacja[j][k] )
				AND ( NOT poset.relacja[k][j] )
			)
			then writeln( 'EUREKA' );
		end;
	end;
end;

//########################################################################################################

var iloscZestawow, kol : Integer;
begin
	SetTextBuf(Input, Buf);
	//nrWypisu := 0;
	zbiorWarstwInic();
	slownikInic( elementyPoszerzajace );
	slownikInic( elementyWWarstwach );
	slownikInic( elementyPosetu );
	read( iloscZestawow );
	for kol:=0 to iloscZestawow-1 do
	begin
		posetPrzeczytaj();
		//superTest();
		znajdzPrzyparz();
		wypiszLancuchy();
	end
end.
